""" File:  incrementingThreads.py   Illustrates concurrency with multiple threads."""
import random
from threading import Thread
from time import clock

class IncrementingThread(Thread):
    """Represents an incrementing thread"""

    def __init__(self, number, counterListRef, increment):
        """Create a thread with the given name and
        increments the counter by incrementAmount"""
        Thread.__init__(self, name = "Thread "+ str(number))
        self._counterList = counterListRef
        self._incrementAmount = increment

    def run(self):
        """Increments the counter by the incrementAmount by a loop."""
        for count in xrange(self._incrementAmount):
            self._counterList[0] += 1
        print self.getName(), "is done."

def main():
    """Create the user's number of threads.  Then start the threads."""
    maxThreads = input("Enter maximum number of threads: ")
    targetAmount = input("Enter number of times all threads should increment: ")
    for numThreads in xrange(1,maxThreads+1):
        start = clock()
        incrementAmount = targetAmount/numThreads
        incrementAmountLastThread = targetAmount - (numThreads-1)*(incrementAmount)

        threadList = []
        counter=[0]
        for count in xrange(numThreads-1):
            threadList.append(IncrementingThread(count+1, counter, incrementAmount))
        threadList.append(IncrementingThread(numThreads, counter, incrementAmountLastThread))
        for thread in threadList:
            thread.start()
        allThreadsDone = False
        while not allThreadsDone:
            allThreadsDone = True
            for thread in threadList:
                if thread.isAlive():
                    allThreadsDone = False
        end = clock()
        runTime = end - start
        print "Counter should be", targetAmount,"but the counter =",counter, "with a",
        print "time of %.6f sec." % runTime

main()
raw_input("Hit <Enter> to quit")
