# timeSearches.py
"""Times sequential search, two recursive binary search algorithms and two \
recursive binary search algorithms"""
from time import clock
import binarySearchRecursive
import binarySearchIterative
import binarySearchRecursiveLocation
import binarySearchIterativeLocation
from orderedSequentialSearch import orderedSequentialSearch

testSize = 10000                       # Number of items to search consisting of
evenList = range(0, 2*testSize, 2)     # even numbers from 0 to 2*(testSize-1)

start = clock()
for target in range(2*testSize):
    orderedSequentialSearch(evenList, target)
# end for
end = clock()
runTime = end - start
print "Time to run orderSequentialSearch on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)

start = clock()
for target in range(2*testSize):
    binarySearchRecursive.binarySearch(evenList, target)
# end for
end = clock()
runTime = end - start
print "Time to run Recursive BinarySearch on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)

start = clock()
for target in range(2*testSize):
    binarySearchIterative.binarySearch(evenList, target)
# end for
end = clock()
runTime = end - start
print "Time to run Iterative BinarySearch on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)

start = clock()
for target in range(2*testSize):
    binarySearchRecursiveLocation.binarySearch(evenList, target,
                                               0, len(evenList)-1)
# end for
end = clock()
runTime = end - start
print "Time to run Recursive BinarySearch to locate targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)

start = clock()
for target in range(2*testSize):
    binarySearchIterativeLocation.binarySearch(evenList, target)
# end for
end = clock()
runTime = end - start
print "Time to run Iterative BinarySearch to locate targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)




