"""
Server with Client Handler for providing day and time.
"""

from socket import *
from time import ctime
from threading import Thread

class ClientHandler(Thread):
    """ Handles a client request. """
    def __init__(self, client):
        Thread.__init__(self)
        self._client = client

    def run(self):
        self._client.send(ctime() + '\nHave a nice day!')
        client.close()                              # Close the connection
        

HOST = 'localhost'
PORT = 5000
ADDRESS = (HOST, PORT)

server = socket(AF_INET, SOCK_STREAM)   # Create a socket
server.bind(ADDRESS)                    # Bind server to host and port
server.listen(5)                        # Listen for up to 5 requests

while True:
    print 'Waiting for a connection...'
    client, address = server.accept()           # Accept connection from a client
    print '... connected from:',address
    handler = ClientHandler(client)
    handler.start()

